Release
curl --request POST \
--url https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"expectedDraftVersion": 4503599627370495,
"expectedStructureVersion": 4503599627370495,
"expectedItemsFingerprint": "<string>",
"idempotencyKey": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"note": "<string>"
}
'import requests
url = "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions"
payload = {
"expectedDraftVersion": 4503599627370495,
"expectedStructureVersion": 4503599627370495,
"expectedItemsFingerprint": "<string>",
"idempotencyKey": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"note": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
expectedDraftVersion: 4503599627370495,
expectedStructureVersion: 4503599627370495,
expectedItemsFingerprint: '<string>',
idempotencyKey: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
note: '<string>'
})
};
fetch('https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'expectedDraftVersion' => 4503599627370495,
'expectedStructureVersion' => 4503599627370495,
'expectedItemsFingerprint' => '<string>',
'idempotencyKey' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'note' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions"
payload := strings.NewReader("{\n \"expectedDraftVersion\": 4503599627370495,\n \"expectedStructureVersion\": 4503599627370495,\n \"expectedItemsFingerprint\": \"<string>\",\n \"idempotencyKey\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"note\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"expectedDraftVersion\": 4503599627370495,\n \"expectedStructureVersion\": 4503599627370495,\n \"expectedItemsFingerprint\": \"<string>\",\n \"idempotencyKey\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"note\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"expectedDraftVersion\": 4503599627370495,\n \"expectedStructureVersion\": 4503599627370495,\n \"expectedItemsFingerprint\": \"<string>\",\n \"idempotencyKey\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"note\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"number": 123,
"note": "<string>",
"releasedAt": "2023-11-07T05:31:56Z",
"releasedBy": {
"id": "<string>",
"name": "<string>"
},
"archivedAt": "2023-11-07T05:31:56Z",
"summary": {
"ceiling": "<string>",
"targetMarginPct": "<string>",
"envelope": "<string>",
"hard": "<string>",
"allocated": "<string>",
"unallocated": "<string>"
},
"snapshot": {
"softCosts": {
"itemCount": 123,
"records": [
{
"id": "<string>",
"typeId": "<string>",
"name": "<string>",
"archived": true
}
],
"itemsFingerprint": "<string>"
},
"schema": 123,
"config": {
"method": "manual",
"softCostAllocations": {},
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"derived": {
"softCostBudgets": {},
"ceiling": "<string>",
"profit": "<string>",
"envelope": "<string>",
"hard": "<string>",
"contingency": "<string>",
"allocated": "<string>",
"unallocated": "<string>",
"softCostBudgetTotal": "<string>"
},
"areas": [
{
"areaId": "<string>",
"parentId": "<string>",
"depth": 123,
"order": 123,
"name": "<string>",
"instanceCount": 123,
"effectiveInstanceCount": 123,
"squareArea": "<string>",
"rate": "<string>",
"manualAmount": "<string>",
"own": "<string>",
"total": "<string>"
}
],
"categories": [
{
"workspaceCategoryId": "<string>",
"name": "<string>",
"segmentKey": "<string>",
"segmentName": "<string>",
"softCostDefaults": {},
"rule": {
"mode": "percent",
"value": "<string>"
},
"allocation": "<string>",
"sharePct": "<string>",
"effectiveMarginPct": "<string>",
"marginOverridden": true,
"defaultMarkupPct": "<string>",
"effectiveMarkupPct": "<string>",
"equivalentMarginPct": "<string>",
"markupFromProject": true,
"sellAllocation": "<string>"
}
],
"segments": [
{
"key": "<string>",
"name": "<string>",
"allocated": "<string>"
}
],
"warnings": [
"CEILING_MISSING"
]
}
}Project Budget Versions
Release
POST
/
v1
/
workspaces
/
{workspaceId}
/
projects
/
{projectId}
/
budget
/
versions
Release
curl --request POST \
--url https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"expectedDraftVersion": 4503599627370495,
"expectedStructureVersion": 4503599627370495,
"expectedItemsFingerprint": "<string>",
"idempotencyKey": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"note": "<string>"
}
'import requests
url = "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions"
payload = {
"expectedDraftVersion": 4503599627370495,
"expectedStructureVersion": 4503599627370495,
"expectedItemsFingerprint": "<string>",
"idempotencyKey": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"note": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
expectedDraftVersion: 4503599627370495,
expectedStructureVersion: 4503599627370495,
expectedItemsFingerprint: '<string>',
idempotencyKey: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
note: '<string>'
})
};
fetch('https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'expectedDraftVersion' => 4503599627370495,
'expectedStructureVersion' => 4503599627370495,
'expectedItemsFingerprint' => '<string>',
'idempotencyKey' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'note' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions"
payload := strings.NewReader("{\n \"expectedDraftVersion\": 4503599627370495,\n \"expectedStructureVersion\": 4503599627370495,\n \"expectedItemsFingerprint\": \"<string>\",\n \"idempotencyKey\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"note\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"expectedDraftVersion\": 4503599627370495,\n \"expectedStructureVersion\": 4503599627370495,\n \"expectedItemsFingerprint\": \"<string>\",\n \"idempotencyKey\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"note\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.specurate.com/api/v1/workspaces/{workspaceId}/projects/{projectId}/budget/versions")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"expectedDraftVersion\": 4503599627370495,\n \"expectedStructureVersion\": 4503599627370495,\n \"expectedItemsFingerprint\": \"<string>\",\n \"idempotencyKey\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"note\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"number": 123,
"note": "<string>",
"releasedAt": "2023-11-07T05:31:56Z",
"releasedBy": {
"id": "<string>",
"name": "<string>"
},
"archivedAt": "2023-11-07T05:31:56Z",
"summary": {
"ceiling": "<string>",
"targetMarginPct": "<string>",
"envelope": "<string>",
"hard": "<string>",
"allocated": "<string>",
"unallocated": "<string>"
},
"snapshot": {
"softCosts": {
"itemCount": 123,
"records": [
{
"id": "<string>",
"typeId": "<string>",
"name": "<string>",
"archived": true
}
],
"itemsFingerprint": "<string>"
},
"schema": 123,
"config": {
"method": "manual",
"softCostAllocations": {},
"manualCeiling": "<string>",
"targetMarginPct": "<string>",
"contingencyPct": "<string>"
},
"derived": {
"softCostBudgets": {},
"ceiling": "<string>",
"profit": "<string>",
"envelope": "<string>",
"hard": "<string>",
"contingency": "<string>",
"allocated": "<string>",
"unallocated": "<string>",
"softCostBudgetTotal": "<string>"
},
"areas": [
{
"areaId": "<string>",
"parentId": "<string>",
"depth": 123,
"order": 123,
"name": "<string>",
"instanceCount": 123,
"effectiveInstanceCount": 123,
"squareArea": "<string>",
"rate": "<string>",
"manualAmount": "<string>",
"own": "<string>",
"total": "<string>"
}
],
"categories": [
{
"workspaceCategoryId": "<string>",
"name": "<string>",
"segmentKey": "<string>",
"segmentName": "<string>",
"softCostDefaults": {},
"rule": {
"mode": "percent",
"value": "<string>"
},
"allocation": "<string>",
"sharePct": "<string>",
"effectiveMarginPct": "<string>",
"marginOverridden": true,
"defaultMarkupPct": "<string>",
"effectiveMarkupPct": "<string>",
"equivalentMarginPct": "<string>",
"markupFromProject": true,
"sellAllocation": "<string>"
}
],
"segments": [
{
"key": "<string>",
"name": "<string>",
"allocated": "<string>"
}
],
"warnings": [
"CEILING_MISSING"
]
}
}Authorizations
Path Parameters
Body
application/json
⌘I